﻿using System;
using System.Threading;

namespace Homework4ReadWriteLock
{
    class Program
    {
        static ReaderWriterLock readWriteLock;
        static void Main(string[] args)
        {
            readWriteLock = new ReaderWriterLock();
            readWriteLock.AcquireWriterLock(-1);
            new Thread(AcceptClients).Start();
            try
            {
                Console.WriteLine("Writer lock acquired reader lock wait until release after 20 seconds.");
                for(int i = 1; i<=20; i++)
                {
                    Thread.Sleep(1000);
                    Console.Write(".");
                }
            } finally
            {
                readWriteLock.ReleaseWriterLock();
            }
        }

        static public void AcceptClients()
        {
            readWriteLock.AcquireReaderLock(-1);
            try
            {
                Console.WriteLine("Writer lock released, acquired reader lock.");
            } finally
            {
                readWriteLock.ReleaseReaderLock();
                Console.WriteLine("Read lock released program finished.");
            }
        }
    }
}
